#include "vtkImageData.h"
#include "vtkMetaImageReader.h"
#include "vtkMetaImageWriter.h"
#include "IRMCore.h"

int main(int argc, char *argv[])
{
	vtkMetaImageReader *reader = vtkMetaImageReader::New();
	std::string filenameIn = ".../FILENAME.mhd"; 	   
	reader->SetFileName( filenameIn.c_str() );
	reader->Update();

	vtkImageData *img = reader->GetOutput();

	std::string datadir= ".../DATADIR";
	IRMCore *core = new IRMCore(datadir);
	core->createADC(1, datadir, 0, 100);

	vtkImageData * carto = vtkImageData::New( );
	//carto = Code_solene(img);

	vtkMetaImageWriter *writer = vtkMetaImageWriter::New( );
	std::string filenameOut= "../FILENAME.mhd";
	writer->SetInput( carto );
	writer->SetFileName( filenameOut.c_str() );
	writer->SetFileDimensionality( 3 );
	writer->Write( );

	return 0;
}
