//----------------------------------------------------------------------------------------------------------------
// Class definition include
//----------------------------------------------------------------------------------------------------------------
#include "IRMCreate.h"

using namespace std;

/*************************************************************************************************************/
/*Constructors & Destructors**********************************************************************************/
/*************************************************************************************************************/

IRMCreate::IRMCreate(double res_temp,int nbbaseline, int delay, double eps, int min, int max,double TE, double thresnoise, int retard_AIF, int retard_perf)
{
	carto=new IRMCarto(res_temp, nbbaseline, delay, eps, min, max, TE,thresnoise, retard_AIF, retard_perf);
}

/************************************************************************************/
IRMCreate::~IRMCreate()
{
    printf("EED IRMCarto::~IRMCreate\n");
}

/*************************************************************************************************************/
/*Ajout, suppression, selection d'images**********************************************************************/
/*************************************************************************************************************/

/*Methode qui appelle la methode du meme nom de la classe IRMCarto********************/
std::vector<vtkImageData*> IRMCreate::getVectImages()
{
	return(carto->getVectImages());
}

/*Methode qui appelle la methode du meme nom de la classe IRMCarto********************/
void IRMCreate::addImage(vtkImageData *img)
{
	carto->addImage(img);
}

/*Methode qui appelle la methode du meme nom de la classe IRMCarto********************/
void IRMCreate::removeImage(int selected)
{
	carto->removeImage(selected);
}

/*Methode qui appelle la methode du meme nom de la classe IRMCarto********************/
vtkImageData * IRMCreate::getSelectedImage(int pos)
{
	return (carto->getSelectedImage(pos));
}

/*************************************************************************************************************/
/*Ajout, suppression, selection d'images moyennees************************************************************/
/*************************************************************************************************************/
std::vector<vtkImageData*> IRMCreate::getVectImagesMoy()
{
	return (carto->getVectImagesMoy());
}

void IRMCreate::addImageMoy(vtkImageData *img)
{
	carto->addImageMoy(img);
}

void IRMCreate::removeImageMoy(int selected)
{
	carto->removeImageMoy(selected);
}

vtkImageData* IRMCreate::getSelectedImageMoy(int pos)
{
	return (carto->getSelectedImageMoy(pos));
}
/*************************************************************************************************************/
/*Ajout, suppression, selection des sequences de concentration************************************************/
/*************************************************************************************************************/
std::vector<vtkImageData*> IRMCreate::getVectSeqCon()
{
	return(carto->getVectSeqCon());
}

/*Methode qui ajoute la vtkImageData en derniere position du vecteur*******************/
void IRMCreate::addSeqCon(vtkImageData *img)
{
	carto->addSeqCon(img);
}

/*Methode qui supprime la vtkImageData a la position selected*************************/
void IRMCreate::removeSeqCon(int selected)
{
	carto->removeSeqCon(selected);
}

/*Methode qui retourne la vtkImageData doint TE, int thresnoisent la position est pos**********************/
vtkImageData* IRMCreate::getSelectedSeqCon(int pos)
{
	return (carto->getSelectedSeqCon(pos));
}

/*************************************************************************************************************/
/*Accesseurs et mutateurs de la classe************************************************************************/
/*************************************************************************************************************/

std::vector<vtkImageData*> IRMCreate::getVectMAX()
{
	return VectMAX;
}

/************************************************************************************/
std::vector<vtkImageData*> IRMCreate::getVectTTP()
{
	return VectTTP;
}
	
/************************************************************************************/
std::vector<vtkImageData*> IRMCreate::getVectMTTSVD()
{
	return VectMTTSVD;
}

/************************************************************************************/
std::vector<vtkImageData*> IRMCreate::getVectCBVSVD()
{
	return VectCBVSVD;
}

/************************************************************************************/
std::vector<vtkImageData*> IRMCreate::getVectCBFSVD()
{
	return VectCBFSVD;
}	

/************************************************************************************/
std::vector<vtkImageData*> IRMCreate::getVectTMAXSVD()
{
	return VectTMAXSVD;
}

/************************************************************************************/
std::vector<vtkImageData*> IRMCreate::getVectMTTARMA()
{
	return VectMTTARMA;
}
	
/************************************************************************************/
std::vector<vtkImageData*> IRMCreate::getVectCBVARMA()
{
	return VectCBVARMA;
}
	
/************************************************************************************/
std::vector<vtkImageData*> IRMCreate::getVectCBFARMA()
{
	return VectCBFARMA;
}	

IRMCarto* IRMCreate::getCarto()
{
	return carto;
}

/*************************************************************************************************************/
/*Moyennage des images****************************************************************************************/
/*************************************************************************************************************/
void IRMCreate::MoyennageImage(int inputImage)
{
	vnl_matrix<double> filtre(3,3,0.111);
	carto->moyennage3x3(getSelectedImage(inputImage),filtre);	
}

/*************************************************************************************************************/
/*Calcul des sequences de concentration***********************************************************************/
/*************************************************************************************************************/
void IRMCreate::CalculSeqCon(int inputImage)
{
	carto->construct_seqcon(getSelectedImageMoy(inputImage));
}

/*************************************************************************************************************/
/*Calcul des cartographies************************************************************************************/
/*************************************************************************************************************/

void IRMCreate::createCartoMAX_TTP(int inputImage, vtkImageData *image_max, vtkImageData *image_ttp)
{
        double maxValue;
	int posValue;
	double result;
	int index_lignes,index_colonnes;
	double res_temp=carto->getrestemp();
	double valeur_ttp;

	//recuperation des dimensions des sequences
	carto->setDimSeqCon(getSelectedSeqCon(inputImage));
	int sizeX=carto->getDimSeqCon(1);
	int sizeY=carto->getDimSeqCon(0);

	//initialisation des vtkImageData
	image_max->SetDimensions(sizeY,sizeX,1);
	image_max->SetScalarTypeToDouble();
	image_max->SetExtent(0, sizeY-1, 0, sizeX-1, 0, 0);
	image_max->SetNumberOfScalarComponents(1);
	image_max->AllocateScalars();

	image_ttp->SetDimensions(sizeY,sizeX,1);
	image_ttp->SetScalarTypeToDouble();
	image_ttp->SetExtent(0, sizeY-1, 0, sizeX-1, 0, 0);
	image_ttp->SetNumberOfScalarComponents(1);
	image_ttp->AllocateScalars();

	for(index_lignes=0;index_lignes<sizeX;index_lignes++)
	{ 
		for(index_colonnes=0;index_colonnes<sizeY;index_colonnes++)
		{
			carto->setVectConcentration(getSelectedSeqCon(inputImage),index_colonnes,index_lignes);
			//carto->setVectConcentration(getSelectedImageMoy(inputImage),index_colonnes,index_lignes);

			if((carto->getVectConcentration().mean())>0)
			{
				carto->maxvecteur(carto->getVectConcentration(),&maxValue,&posValue);
				result=(double)posValue;
				valeur_ttp=result*res_temp;
				image_max->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, maxValue);
				image_ttp->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0,valeur_ttp);
			}

			else
			{
				image_max->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, 0);
				image_ttp->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, 0); 
			}
		}
	}

	//ajout des vtkImageData aux vecteurs
	VectMAX.push_back(image_max);
	VectTTP.push_back(image_ttp);	
}

/************************************************************************************/
void IRMCreate::createCartoSVD(int inputImage, vnl_matrix<double> entree_arterielle, vtkImageData *image_mtt, vtkImageData *image_cbv, vtkImageData *image_cbf, vtkImageData *image_tmax)
{
	int index_lignes, index_colonnes;
	double mtt,cbv,cbf;			
	int tmax;
	double result, val_tmax;
	double res_temp;
	double val_mtt;

  	//recuperation des dimensions des sequences
	carto->setDimSeqCon(getSelectedSeqCon(inputImage));
	int sizeX=carto->getDimSeqCon(1);
	int sizeY=carto->getDimSeqCon(0);

	//initialisation des vtkImageData
	image_mtt->SetDimensions(sizeY,sizeX,1);
	image_mtt->SetScalarTypeToDouble();
	image_mtt->SetExtent(0, sizeY-1, 0, sizeX-1, 0, 0);
	image_mtt->SetNumberOfScalarComponents(1);
	image_mtt->AllocateScalars();

	image_cbv->SetDimensions(sizeY,sizeX,1);
	image_cbv->SetScalarTypeToDouble();
	image_cbv->SetExtent(0, sizeY-1, 0, sizeX-1, 0, 0);
	image_cbv->SetNumberOfScalarComponents(1);
	image_cbv->AllocateScalars();

	image_cbf->SetDimensions(sizeY,sizeX,1);
	image_cbf->SetScalarTypeToDouble();
	image_cbf->SetExtent(0, sizeY-1, 0, sizeX-1, 0, 0);
	image_cbf->SetNumberOfScalarComponents(1);
	image_cbf->AllocateScalars();

	image_tmax->SetDimensions(sizeY,sizeX,1);
	image_tmax->SetScalarTypeToDouble();
	image_tmax->SetExtent(0, sizeY-1, 0, sizeX-1, 0, 0);
	image_tmax->SetNumberOfScalarComponents(1);
	image_tmax->AllocateScalars();	

	for(index_lignes=0;index_lignes<sizeX;index_lignes++)
	{	 
		for(index_colonnes=0;index_colonnes<sizeY;index_colonnes++)
		{		  
			carto->setVectConcentration(getSelectedSeqCon(inputImage),index_colonnes,index_lignes);
			
			if((carto->getVectConcentration().mean())>0)
			{
				  carto->mttr_tmax(carto->calculSVD(carto->vectligne2col(carto->getVectConcentration()),entree_arterielle));    				  
				  mtt=carto->getmtt();
				  cbv=carto->getcbv();
				  tmax=carto->gettmax();
				  res_temp=carto->getrestemp();

				  if(isinf(mtt) || isnan(mtt) || mtt<0 || isinf(cbv) || isnan(cbv) || cbv<0 || isinf(tmax) || isnan(tmax) ||  tmax<0)
				  {
					  image_mtt->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, 0);
					  image_cbv->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, 0);
					  image_cbf->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, 0);
					  image_tmax->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, 0);
				  }

				  else
				  {
					  val_mtt= mtt*res_temp;
					  image_mtt->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, val_mtt);
					  image_cbv->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, cbv);
					  cbf=(cbv/val_mtt)*60;
					  image_cbf->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, cbf);
					  result=(double)tmax;
					  val_tmax=result*res_temp;
					  image_tmax->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0,val_tmax);				  
				   }
			}

			else
			{
				  image_mtt->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, 0);
				  image_cbv->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, 0);
				  image_cbf->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, 0);
				  image_tmax->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, 0); 	
			}
		}
	}

	//ajout des vtkImageData aux vecteurs
	VectMTTSVD.push_back(image_mtt);
	VectCBVSVD.push_back(image_cbv);
	VectCBFSVD.push_back(image_cbf);
	VectTMAXSVD.push_back(image_tmax);	
}

/*Methode ARMA***********************************************************************************/
void IRMCreate::createCartoARMA(int inputImage,vnl_matrix<double> entree_arterielle,vtkImageData *image_mtt, vtkImageData *image_cbv, vtkImageData *image_cbf)
{
	int index_lignes, index_colonnes;
	double mtt,cbv,cbf;			
	double res_temp;
	double val_mtt;

  	//recuperation des dimensions des sequences
	carto->setDimSeqCon(getSelectedSeqCon(inputImage));
	int sizeX=carto->getDimSeqCon(1);
	int sizeY=carto->getDimSeqCon(0);

	//initialisation des vtkImageData
	image_mtt->SetDimensions(sizeY,sizeX,1);
	image_mtt->SetScalarTypeToDouble();
	image_mtt->SetExtent(0, sizeY-1, 0, sizeX-1, 0, 0);
	image_mtt->SetNumberOfScalarComponents(1);
	image_mtt->AllocateScalars();

	image_cbv->SetDimensions(sizeY,sizeX,1);
	image_cbv->SetScalarTypeToDouble();
	image_cbv->SetExtent(0, sizeY-1, 0, sizeX-1, 0, 0);
	image_cbv->SetNumberOfScalarComponents(1);
	image_cbv->AllocateScalars();

	image_cbf->SetDimensions(sizeY,sizeX,1);
	image_cbf->SetScalarTypeToDouble();
	image_cbf->SetExtent(0, sizeY-1, 0, sizeX-1, 0, 0);
	image_cbf->SetNumberOfScalarComponents(1);
	image_cbf->AllocateScalars();

	for(index_lignes=0;index_lignes<sizeX;index_lignes++)
	{	 
		for(index_colonnes=0;index_colonnes<sizeY;index_colonnes++)
		{		  
			carto->setVectConcentration(getSelectedSeqCon(inputImage),index_colonnes,index_lignes);
			
			if((carto->getVectConcentration().mean())>0)
			{
				  carto->calculARMA(carto->vectligne2col(carto->getVectConcentration()),entree_arterielle,1,1);
				  carto->cbv_arma();
				  mtt=carto->getmtt();
				  cbv=carto->getcbv();
				  res_temp=carto->getrestemp();
				  cbf=carto->getcbf();
				  
				  if(isinf(mtt) || isnan(mtt) || mtt<0 || isinf(cbv) || isnan(cbv) || cbv<0)
				  {
					  image_mtt->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, 0);
					  image_cbv->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, 0);
					  image_cbf->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, 0);
				  }

				  else
				  {
					  val_mtt= mtt*res_temp;
					  image_mtt->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, val_mtt);
					  image_cbv->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, cbv);
					  image_cbf->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, cbf);
				   }  
			}
			else
			{
				  image_mtt->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, 0);
				  image_cbv->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, 0);
				  image_cbf->SetScalarComponentFromDouble(index_colonnes,index_lignes,0, 0, 0);
			}
		}
	}

	//ajout des vtkImageData aux vecteurs
	VectMTTARMA.push_back(image_mtt);
	VectCBVARMA.push_back(image_cbv);
	VectCBFARMA.push_back(image_cbf);
}

/*************************************************************************************************************/
/*Affichage et enregistrement des cartographies***************************************************************/
/*************************************************************************************************************/
      
void IRMCreate::affichageImage(vtkImageData *img)
{
	vtkRenderWindowInteractor *iren = vtkRenderWindowInteractor::New();
	vtkImageViewer2 *viewer = vtkImageViewer2::New();
	viewer->SetInput (img);
	viewer->SetupInteractor (iren);
	viewer->Render();
	iren->Initialize();
	iren->Start(); 
}

/************************************************************************************/
//void IRMCreate::enregistrerImage(vtkImageData *img, char *nom)
void IRMCreate::enregistrerImage(std::vector<vtkImageData*> vect, char *nom, int nb)
{
	int index_image, index_lignes, index_colonnes,index_temps;
	carto->setDim(vect.at(0));
	int sizeX=carto->getDim(1);
	int sizeY=carto->getDim(0);
	int sizeZ=carto->getDim(2);
	int size=nb*sizeZ;

	vtkImageData *img=vtkImageData::New();
	img->SetDimensions(sizeY,sizeX,size);
	img->SetScalarTypeToDouble();
	img->SetExtent(0, sizeY-1, 0, sizeX-1, 0, size-1);
	img->SetNumberOfScalarComponents(1);
	img->AllocateScalars();

	for(index_image=0; index_image<nb;index_image++)
	{
		for(index_temps=0; index_temps<sizeZ;index_temps++)
		{
		      for(index_lignes=0; index_lignes<sizeX;index_lignes++)
		      {
			      for(index_colonnes=0; index_colonnes<sizeX;index_colonnes++)
			      {
				      img->SetScalarComponentFromDouble(index_colonnes,index_lignes,(index_image* sizeZ)+index_temps,0,(vect.at(index_image))->GetScalarComponentAsDouble(index_colonnes,index_lignes,index_temps,0));
			      }
		      }
		}
	}
	vtkMetaImageWriter *writer = vtkMetaImageWriter::New();
	writer->SetFileName(nom);
	writer->SetInput(img);
	writer->SetCompression(false);
	writer->Write();
}

void IRMCreate::enregistrercarto(std::vector<vtkImageData*> vect, char *nom, int nb)
{
std::cout << "ecriture [" << nom << "]" << std::endl;

	int index_image, index_lignes, index_colonnes;
	carto->setDim(vect.at(0));
	int sizeX=carto->getDim(1);
	int sizeY=carto->getDim(0);

	vtkImageData *img=vtkImageData::New();
	img->SetDimensions(sizeY,sizeX,nb);
	img->SetScalarTypeToDouble();
	img->SetExtent(0, sizeY-1, 0, sizeX-1, 0, nb-1);
	img->SetNumberOfScalarComponents(1);
	img->AllocateScalars();

	for(index_image=0; index_image<nb; index_image++)
	{
		for(index_lignes=0; index_lignes<sizeX;index_lignes++)
		{
			for(index_colonnes=0; index_colonnes<sizeY;index_colonnes++)
			{
				img->SetScalarComponentFromDouble(index_colonnes,index_lignes,index_image,0,(vect.at(index_image))->GetScalarComponentAsDouble(index_colonnes,index_lignes,0,0));
			}
		}
	}
	vtkMetaImageWriter *writer = vtkMetaImageWriter::New();
	writer->SetFileName(nom);
	writer->SetInput(img);
	writer->SetCompression(false);
	writer->Write();
}
