//----------------------------------------------------------------------------------------------------------------
// Class definition include
//----------------------------------------------------------------------------------------------------------------
#include "IRMCore.h"
#include "IRMCreate.h"
#include "time.h"

IRMCore::IRMCore(std::string datadir)
{
	_datadir=datadir;
}

IRMCore::~IRMCore()
{
	printf("EED IRMCore::~IRMCore\n");
}

std::vector<vtkImageData*> IRMCore::getVectImages()
{
	return _vectimages;
}

void IRMCore::addImage(vtkImageData * img)
{
	_vectimages.push_back(img);
}

void IRMCore::removeImage(int selected)
{
	_vectimages.erase (_vectimages.begin()+(selected));
}

vtkImageData * IRMCore::getSelectedImage(int pos)
{
	return _vectimages[pos];
}

// Should receive a std::vector<std::vtkImageData>, not an int !                    // JPR 
void IRMCore::createADC(int inputImage, std::string path, int min, int max)
{
   // \TODO : call Solene's code
   std::cout << "in IRMCore::createADC, should call Solene's code" << std::endl;
}


// better pass a reference on std::vector<vtkImageData *> // JPR
void IRMCore::createTTP(std::vector<vtkImageData *> &output, 
			std::string path,
			int min,
			int max,
			std::string ficEntreeArt,
			double res_temp,
			int nbbaseline,
			int delay, 		    // useless MW
			double eps, 		// useless MW
			double TE,
			double thresnoise,
			int retard_AIF, 	// useless MW
			int retard_perf,	// useless MW
			bool verbose,
			bool cartoMax,
			bool cartoSVD,
			bool cartoARMA,
			bool aff,
			bool enreg,
			int firstSliceToDeal  // usefull at check time ! // JPR
			  ) // JPR
{

//   std::cout << "in IRMCore::createTTP, we run Solene's code; try to print  vtkImageData" << std::endl;
//   output[0]->PrintSelf(std::cout, vtkIndent(2));

std::cout << "in IRMCore::createTTP, we run Solene's code; aff " << aff << " enreg " << enreg << std::endl;

// ----------------------- The following should be passed as parameters.----------------

// Just to remember : 'command line' program parameters 
/*
 " dirin=rootDirectoryName                          						      ",
 " nb=number of Slices                                                                   (default : 1)",
 " res_temp=resolution temporelle                                                        (default : 1)",
 " nb_baseline=nombre d images necessaires pour le calcul de la baseline                 (default : 3)",
 " delay= choix du retard :                                                              (default : 0)",
 "						= 0 choix du retard par erreur rms,                                               ",
 "						= 1 ; choix du retard par 1-ier max sur t=0 de la courbe residue                  ",
 "						= 2 ; on prend ret=0 et on retient pour rBF la valeur du max de la courbe residue ",
 " eps=eps sur max des valeurs singulieres 						(default : 0.1)	",
 " min=premiere image a prendre en compte 						(default : 8)	",
 " max=derniere image a prendre en compte 						(default : 100)	",
 " TE=temps d'echo 									(default : 0.05)",
 " thresnoise=seuil de bruit 								(default : 600) ",
 " retard_AIF=nombre de fois ou il faut decaler l entree arterielle  			(default : 1)",
 " retard_perf=nombre de fois ou il faut decaler la sequence de concentration  		(default : 3 ",
 " num_coupe=numero de la coupe par laquelle on veut commencer  			(default : 0)",
 " fichierAIF=nom du fichier contenant l entree arterielle initialise a AIF.csv dans repertoire bin  ",
 " cartoPeak=O si on souhaite generer les cartographies du peak et ttp,    =N, sinon 	(default : 0)",
 " cartoSVD=O  si on souhaite generer les cartographies avec la SVD,       =N, sinon 	(default : 0)",
 " cartoARMA=O si on souhaite generer les cartographies avec ARMA,         =N, sinon 	(default : N)",
 " affichage=O si on souhaite afficher les cartographies generees,         =N, sinon, 	(default : 0)",
 " enregistrement=O si on souhaite enregistrer les cartographies generees, =N, sinon 	(default : 0)",
*/

   // ------------------- copied from Test_Create.cxx ----------------------------

 	// ----- Begin Processing -----

	//std::vector <vtkImageData *> output;
	//char nomFich[1024]; // Hope it's enough !
	std::string nomFich;  // JPR

	IRMCreate *create = new IRMCreate(res_temp, nbbaseline, delay, eps, min, max, TE, thresnoise, retard_AIF, retard_perf/*, firstSliceToDeal*/);

	vnl_matrix<double> entree_arterielle;

        if (cartoSVD || cartoARMA)
		entree_arterielle=(create->getCarto())->lectureAIFdansexcel(ficEntreeArt.c_str());

	int i;
	//int numcoupe=0;
	int nb = output.size();

	// Declare usefull objects, only once;

 	vtkImageData *image_max      = 0;  // JPR
	vtkImageData *image_ttp      = 0;
	vtkImageData *image_mtt_svd  = 0;
	vtkImageData *image_cbv_svd  = 0;
	vtkImageData *image_cbf_svd  = 0;
	vtkImageData *image_tmax_svd = 0;
	vtkImageData *image_mtt_arma = 0;
	vtkImageData *image_cbv_arma = 0;
	vtkImageData *image_cbf_arma = 0;

	//vtkGdcmReader *reader        = 0;

	char nom_max[4096];  // length should be enough  // JP
	char nom_ttp[4096];
	char nom_mttsvd[4096];
	char nom_cbvsvd[4096];
	char nom_cbfsvd[4096];
	char nom_tmaxsvd[4096];
	char nom_mttarma[4096];
	char nom_cbvarma[4096];
	char nom_cbfarma[4096];

/// \TODO use boost! // JPR
#if defined(_WIN32)
	char SEPARATOR = '\';
#else
	char SEPARATOR = '/';
#endif

	for (i = firstSliceToDeal; i < nb; i++)
	{

#if defined(_WIN32)
		system ("date /T");
		char strDate[9];
		char strTime[9];
		_strdate(strDate);
		_strtime(strTime);
		std::cout << strDate << "  " << strTime << std::endl;
#else
	system ("date");
#endif

std::cout << "========================================" << "in IRMCore::createTTP, deal with image " << i << std::endl;

/*		nomFich = inputImageS[i];
		if (verbose)
			std::cout << "file to be processed : [" << nomFich << ")" << std::endl;
		reader->SetFileName(nomFich.c_str());
		reader->Update();
		output.push_back(reader->GetOutput());
*/

		create->addImage(output.at(i));
		create->MoyennageImage(i);
		create->CalculSeqCon(i);
		if(cartoMax)
		{
            /// \TODO : delete the objects, later
			/*if (!image_max) */ image_max = vtkImageData::New();
			/*if (!image_ttp) */ image_ttp = vtkImageData::New();

			//creation cartographies max et ttpmax
			std::cout << "================ creation cartographies max et ttpmax" << std::endl;
			create->createCartoMAX_TTP(i, image_max, image_ttp);
		}

		if(cartoSVD)
		{
		        /// \TODO : delete the objects, later
			/*if (!image_mtt_svd)  */  image_mtt_svd  =  vtkImageData::New();
			/*if (!image_cbv_svd)  */  image_cbv_svd  =  vtkImageData::New();
			/*if (!image_cbf_svd)  */  image_cbf_svd  =  vtkImageData::New();
			/*if (!image_tmax_svd) */  image_tmax_svd =  vtkImageData::New();
			//creation cartographies de la svd
			std::cout << "================ creation cartographies de la svd" << std::endl;
			create->createCartoSVD(i, entree_arterielle, image_mtt_svd, image_cbv_svd, image_cbf_svd, image_tmax_svd);
		}

		if(cartoARMA)
		{
		        /// \TODO : delete the objects, later
			/*if (!image_mtt_arma)  */ image_mtt_arma = vtkImageData::New();
			/*if (!image_cbv_arma)  */ image_cbv_arma = vtkImageData::New();
			/*if (!image_cbf_arma)  */ image_cbf_arma = vtkImageData::New();
			//creation cartographies avec ARMA
			std::cout << "================ creation cartographies avec ARMA" << std::endl;
			create->createCartoARMA(i, entree_arterielle, image_mtt_arma, image_cbv_arma, image_cbf_arma);
		}

aff = false; // infinite loop when true! // JPR

		if(aff)
		{

std::cout << "======================================== 'Affichage' was requiered" << std::endl;
		      create->affichageImage(create->getSelectedImage(i));
		      create->affichageImage(create->getSelectedImageMoy(i));
		      create->affichageImage(create->getSelectedSeqCon(i));

		      if(cartoMax)
		      {
			      create->affichageImage(create->getVectMAX().at(i));
			      create->affichageImage(create->getVectTTP().at(i));
		      }

		      if(cartoSVD)
		      {
			      create->affichageImage((create->getVectMTTSVD()).at(i));
			      create->affichageImage((create->getVectCBVSVD()).at(i));
			      create->affichageImage((create->getVectCBFSVD()).at(i));
			      create->affichageImage((create->getVectTMAXSVD()).at(i));
		      }

		      if(cartoARMA)
		      {
			      create->affichageImage((create->getVectMTTARMA()).at(i));
			      create->affichageImage((create->getVectCBVARMA()).at(i));
			      create->affichageImage((create->getVectCBFARMA()).at(i));
		      }
		}
	}

	if(enreg)
	{
		std::cout << "======================================== 'Enreg' was requiered" << std::endl;
		if(cartoMax)
		{
		std::cout << "path " <<path <<std::endl;
		
			sprintf(nom_max, "%s%c%s",path.c_str(), SEPARATOR, "MAX.mhd");
		std::cout << "nom_max " <<nom_max <<std::endl;	
			create->enregistrercarto(create->getVectMAX(), nom_max, nb);

			sprintf(nom_ttp,"%s%c%s",path.c_str(), SEPARATOR, "TTP.mhd");
			create->enregistrercarto(create->getVectTTP(), nom_ttp, nb);
		}

		if(cartoSVD)
		{
			//char *nom_mttsvd=(char*)malloc(7*sizeof(char));
			//char *nom_cbvsvd=(char*)malloc(7*sizeof(char));
			//char *nom_cbfsvd=(char*)malloc(7*sizeof(char));
			//char *nom_tmaxsvd=(char*)malloc(8*sizeof(char));
			
			sprintf(nom_mttsvd,"%s%c%s",path.c_str(), SEPARATOR, "MTTsvd.mhd");
			create->enregistrercarto(create->getVectMTTSVD(),nom_mttsvd,nb);
			sprintf(nom_cbvsvd,"%s%c%s",path.c_str(), SEPARATOR, "CBVsvd.mhd");
			create->enregistrercarto(create->getVectCBVSVD(),nom_cbvsvd,nb);
			sprintf(nom_cbfsvd,"%s%c%s",path.c_str(), SEPARATOR, "CBFsvd.mhd");
			create->enregistrercarto(create->getVectCBFSVD(),nom_cbfsvd,nb);
			sprintf(nom_tmaxsvd,"%s%c%s",path.c_str(), SEPARATOR, "TMAXsvd.mhd");
			create->enregistrercarto(create->getVectTMAXSVD(),nom_tmaxsvd,nb);
		}

		if(cartoARMA)
		{
			//char *nom_mttarma=(char*)malloc(7*sizeof(char));
			//char *nom_cbvarma=(char*)malloc(7*sizeof(char));
			//char *nom_cbfarma=(char*)malloc(7*sizeof(char));
			sprintf(nom_mttarma,"%s%c%s",path.c_str(), SEPARATOR, "MTTarma.mhd");
			create->enregistrercarto(create->getVectMTTARMA(),nom_mttarma,nb);
			sprintf(nom_cbvarma,"%s%c%s",path.c_str(), SEPARATOR, "CBVarma.mhd");
			create->enregistrercarto(create->getVectCBVARMA(),nom_cbvarma,nb);
			sprintf(nom_cbfarma,"%s%c%s",path.c_str(), SEPARATOR, "CBFarma.mhd");
			create->enregistrercarto(create->getVectCBFARMA(),nom_cbfarma,nb);
		}
	}

	// Delete all objects before leaving!
    /// \TODO : delete *all* of them, not only the last one!  // JPR

 	if(image_max)      image_max->Delete();
	if(image_ttp)      image_ttp->Delete();
	if(image_mtt_svd)  image_mtt_svd->Delete();
	if(image_cbv_svd)  image_cbv_svd->Delete();
	if(image_cbf_svd)  image_cbf_svd->Delete();
	if(image_tmax_svd) image_tmax_svd->Delete();
	if(image_mtt_arma) image_mtt_arma->Delete();
	if(image_cbv_arma) image_cbv_arma->Delete();
	if(image_cbf_arma) image_cbf_arma->Delete();
}

void IRMCore::createPeak(int inputImage, std::string path, int min, int max)
{
   // \TODO : call Solene's code
   std::cout << "in IRMCore::createPeak, should call Solene's code" << std::endl;
}
