#ifndef __IRMCore__
#define __IRMCore__

//------------------------------------------------------------------------------------------------------------
// Includes
//------------------------------------------------------------------------------------------------------------
#include "vtkImageData.h"
#include <vector>
#include <string>

//------------------------------------------------------------------------------------------------------------
// Constructors & Destructors
//------------------------------------------------------------------------------------------------------------
class IRMCore{

public:
	/**
	**	If images are available before the construction of the kernelManager this method should be used
	**	it sets the vector images and initializes the environment
	**/
	IRMCore(std::string datadir);

	~IRMCore();

	std::vector<vtkImageData*> getVectImages();

	void addImage(vtkImageData *img);

	void removeImage(int selected);

	vtkImageData *getSelectedImage(int pos);  // probablely useless, now! // JPR

	void createADC(int inputImage, std::string path, int min, int max);

	void createTTP (std::vector<vtkImageData *> &inputImageS, std::string path, int min, int max, std::string ficEntreeArt,
			double res_temp, int nbbaseline, int delay, double eps, double TE, double thresnoise, int retard_AIF, int retard_perf,
			bool verbose,
			bool cartoMax,
			bool cartoSVD,
			bool cartoARMA,
			bool aff,
			bool enreg,
			int firstSliceToDeal);

	void createPeak(int inputImage, std::string path, int min, int max);

//------------------------------------------------------------------------------------------------------------
// Constants
//------------------------------------------------------------------------------------------------------------

private: 	
//------------------------------------------------------------------------------------------------------------
// Attributes
//------------------------------------------------------------------------------------------------------------
	std::vector<vtkImageData*> _vectimages;

	std::string	_datadir;	
};
#endif
