#include "buttonsContours.h"
#include "buttonsMainPanel.h"

buttonsContours::buttonsContours(wxWindow *parent, int sizex, int sizey, wxEvtHandler* evtHandler, std::string datdir)
	: menuBarButtons(parent, sizex, sizey)
{
	this->datadir = datdir;
	initButtons(this);
}

void buttonsContours::initButtons(wxEvtHandler* evtHandler) 
{
	std::vector<std::string> path, nom;
	std::vector<wxObjectEventFunction> funct;

	path.push_back(datadir + "/Add.png");
	nom.push_back("Launch a new Viewer in the Application");
	funct.push_back((wxObjectEventFunction) &buttonsContours:: onViewerPressed);

	path.push_back(datadir + "/ContourTool.png");
	nom.push_back("Launch the creaContours application");
	funct.push_back((wxObjectEventFunction) &buttonsContours:: onContourPressed);

	path.push_back(datadir + "/AddMIP.png");
	nom.push_back("Launch a MIP Viewer in the Application");
	funct.push_back((wxObjectEventFunction) &buttonsContours:: onMIPViewerPressed);
	
	this->addButtons(path, nom);	
	this->setVectorFunction(funct);

	this->connectEvents(evtHandler);
}

buttonsContours::~buttonsContours()
{

}

/**
 **	Responds to the events of the buttons, when the same panel is in charge of it. It gets the name
 **	of the button corresponding to the method that has to be executed,
 **	it uses attribute eventHandler to call the methods define by the application.
 **	see setEventHandler(wxEventHandler*)
 **/


void buttonsContours::onContourPressed(wxCommandEvent& event)
{
	buttonsMainPanel::getInstance()->onContourPressed();
}

void buttonsContours::onViewerPressed(wxCommandEvent& event)
{
	buttonsMainPanel::getInstance()->onViewerPressed();
}

void buttonsContours::onMIPViewerPressed(wxCommandEvent& event)
{
	buttonsMainPanel::getInstance()->onMIPViewerPressed();
}
