#include "buttonsEdition.h"


buttonsEdition::buttonsEdition(wxWindow * parent, int sizex, int sizey,wxEvtHandler* evtHandler, std::string datdir)
	: menuBarButtons(parent, sizex, sizey)
{
	this->datadir = datdir;
//	eventHandler = evtHandler;
	initButtons(this);
}

void buttonsEdition::initButtons(wxEvtHandler* evtHandler) {

	std::vector<std::string> path, nom;
	std::vector<wxObjectEventFunction> funct;

	path.push_back(datadir + "/copy.png");
	nom.push_back("Copy the selected contour  ctrl + c");
	funct.push_back((wxObjectEventFunction) &buttonsEdition:: onCopy);

	path.push_back(datadir + "/paste.png");
	nom.push_back("Paste the copied contour  ctrl + v");
	funct.push_back((wxObjectEventFunction) &buttonsEdition:: onPaste);

	path.push_back(datadir + "/undo.png");
	nom.push_back("Undo  ctrl + z");
	funct.push_back((wxObjectEventFunction) &buttonsEdition:: onUndo);

	path.push_back(datadir + "/redo.png");
	nom.push_back("Redo  ctrl + y");
	funct.push_back((wxObjectEventFunction) &buttonsEdition:: onRedo);

    this->addButtons(path, nom);
	this->setVectorFunction(funct);

	this->setButtonName(0, 'C');
	this->setButtonName(1, 'P');
	this->setButtonName(2, '-');
	this->setButtonName(3, '-');

	this->connectEvents(evtHandler);

}
void buttonsEdition::onCopy(wxCommandEvent& event){
	buttonsMainPanel::getInstance()->onCopy();
}
void buttonsEdition::onPaste(wxCommandEvent& event){

	buttonsMainPanel::getInstance()->onPaste();
}
void buttonsEdition::onUndo(wxCommandEvent& event){
	buttonsMainPanel::getInstance()->onUndo();
}
void buttonsEdition::onRedo(wxCommandEvent& event){
	buttonsMainPanel::getInstance()->onRedo();
}

buttonsEdition::~buttonsEdition()
{
}

