#include "buttonsIO.h"
#include "buttonsMainPanel.h"

buttonsIO::buttonsIO(wxWindow * parent, int sizex, int sizey,wxEvtHandler* evtHandler, std::string datdir)
	: menuBarButtons(parent, sizex, sizey)
{
	this->datadir = datdir;
//	eventHandler = evtHandler;
	initButtons(this);
}

void buttonsIO::initButtons(wxEvtHandler* evtHandler)
{
	std::vector<std::string> path, nom;
	std::vector<wxObjectEventFunction> funct;

	path.push_back(datadir + "/NewADC.png");
	nom.push_back("Create a New Diffusion Coefficient Image (ADC Cartography)");
	funct.push_back((wxObjectEventFunction) &buttonsIO::onNewADC);

	path.push_back(datadir + "/NewTTP.png");
	nom.push_back("Create a New Time-To-Peak Image (TTP Cartography)");
	funct.push_back((wxObjectEventFunction) &buttonsIO::onNewTTP);

	path.push_back(datadir + "/Save.png");
	nom.push_back("Save all contours created ctrl + s");
	funct.push_back((wxObjectEventFunction) &buttonsIO::onSave);

	this->addButtons(path, nom);
	this->setVectorFunction(funct);

	//this->setButtonName(0, 'O');
	//this->setButtonName(1, ');

	this->connectEvents(evtHandler);
}

void buttonsIO::onNewADC(wxCommandEvent& event)
{
	buttonsMainPanel::getInstance()->onNewADCPressed();
}

void buttonsIO::onNewTTP(wxCommandEvent& event)
{
	buttonsMainPanel::getInstance()->onNewTTPPressed();
}

void buttonsIO::onSave(wxCommandEvent& event)
{
	buttonsMainPanel::getInstance()->onSave();
}

buttonsIO::~buttonsIO()
{

}

