#include "buttonsIRM.h"

buttonsIRM::buttonsIRM(wxWindow * parent, int sizex, int sizey,wxEvtHandler* evtHandler, std::string datdir)
	: menuBarButtons(parent, sizex, sizey)
{
	this->datadir = datdir;
	initButtons(this);
}

void buttonsIRM::initButtons(wxEvtHandler* evtHandler) {

	std::vector<std::string> path, nom;
	std::vector<wxObjectEventFunction> funct;

	path.push_back(datadir + "/Difference.png");
	nom.push_back("Create a differential cartography");
	funct.push_back((wxObjectEventFunction)&buttonsIRM::onDifferential);

	path.push_back(datadir + "/Superposition.png");
	nom.push_back("Superposition and Recalage");
	funct.push_back((wxObjectEventFunction)&buttonsIRM::onSuperposition);

	path.push_back(datadir + "/SignalCurve.png");
	nom.push_back("Signal Curve tool");
	funct.push_back((wxObjectEventFunction)&buttonsIRM::onSignalCurve);

    	this->addButtons(path, nom);

	this->setVectorFunction(funct);	
	this->connectEvents(evtHandler);

}

buttonsIRM::~buttonsIRM()
{
}


void buttonsIRM::onDifferential(wxCommandEvent& event){
	buttonsMainPanel::getInstance()->onDifferentialPressed();
}
void buttonsIRM::onSuperposition(wxCommandEvent& event){
	buttonsMainPanel::getInstance()->onSuperpositionPressed();
}
void buttonsIRM::onSignalCurve(wxCommandEvent& event){
	buttonsMainPanel::getInstance()->onSignalCurvePressed();
}

