#include "buttonsMainPanel.h"

buttonsMainPanel* buttonsMainPanel::mainPanel=NULL;

buttonsMainPanel::buttonsMainPanel(wxWindow * parent, int sizex, int sizey, wxEvtHandler * evtHandler, std::string datadir)
: wxPanel(parent, -1, wxDefaultPosition, wxSize(sizex, sizey), wxBORDER_SUNKEN)
{

/// \TODO : find clever names for that; re-arange the tools inside each group, to make each group more re-usable! // JPR

	PANEL1 = "I/O";
	PANEL2 = "Edit";
	PANEL3 = "IRM Tools";
	PANEL4 = "Contour Tool";

	differentialPanel  = NULL;
	superpositionPanel = NULL;
	signalCurvePanel   = NULL;
	contourPanel       = NULL;
	ADCPanel           = NULL;
	TTPPanel           = NULL;

	splitterwindow = new wxSplitterWindow(this,-1, wxDefaultPosition, wxSize(sizex, sizey), wxSP_3DSASH, wxString(_T("")));

	sizey = sizey/8;
	currentWindow = NULL;

	wxPanel* toolpanel = new wxPanel(splitterwindow, -1, wxDefaultPosition, wxDefaultSize, wxBORDER_NONE, wxString(_T("")));

	wxFlexGridSizer* flexsizer = new wxFlexGridSizer(6,2,1,1);	
	toolpanel->SetSizer(flexsizer, true);
	toolpanel->SetAutoLayout( true );

	wxButton* b1 = getButton(toolpanel);
	b1->SetClientData(&PANEL1);
	wxButton* b2 = getButton(toolpanel);
	b2->SetClientData(&PANEL2);
	wxButton* b3 = getButton(toolpanel);
	b3->SetClientData(&PANEL3);
	wxButton* b4 = getButton(toolpanel);
	b4->SetClientData(&PANEL4);

	wxPanel* mentex1 = new wxPanel(toolpanel, -1, wxDefaultPosition, wxDefaultSize, wxBORDER_NONE, wxString(_T("")));
	wxPanel* mentex2 = new wxPanel(toolpanel, -1, wxDefaultPosition, wxDefaultSize, wxBORDER_NONE, wxString(_T("")));
	wxPanel* mentex3 = new wxPanel(toolpanel, -1, wxDefaultPosition, wxDefaultSize, wxBORDER_NONE, wxString(_T("")));
	wxPanel* mentex4 = new wxPanel(toolpanel, -1, wxDefaultPosition, wxDefaultSize, wxBORDER_NONE, wxString(_T("")));

	menubar1 = new buttonsIO      (mentex1, sizex, sizey, evtHandler, datadir);	
	menubar2 = new buttonsEdition (mentex2, sizex, sizey, evtHandler, datadir);	
	menubar3 = new buttonsIRM     (mentex3, sizex, sizey, evtHandler, datadir);	
	menubar4 = new buttonsContours(mentex4, sizex, sizey, evtHandler, datadir);

	statictext1 = getText(mentex1, PANEL1);	
	statictext2 = getText(mentex2, PANEL2);	
	statictext3 = getText(mentex3, PANEL3);	
	statictext4 = getText(mentex4, PANEL4);

	flexsizer->Add(b1, wxFIXED_MINSIZE);
	flexsizer->Add(setMenuTextSizer(mentex1, menubar1,statictext1), wxFIXED_MINSIZE);

	flexsizer->Add(b2, wxFIXED_MINSIZE);
	flexsizer->Add(setMenuTextSizer(mentex2, menubar2,statictext2), wxFIXED_MINSIZE);

	flexsizer->Add(b3, wxFIXED_MINSIZE);
	flexsizer->Add(setMenuTextSizer(mentex3, menubar3,statictext3), wxFIXED_MINSIZE);

	flexsizer->Add(b4, wxFIXED_MINSIZE);
	flexsizer->Add(setMenuTextSizer(mentex4, menubar4,statictext4), wxFIXED_MINSIZE);

	toolpanel->Update();
	toolpanel->Layout();

	infoPanel = new wxPanel(splitterwindow, -1, wxDefaultPosition, wxDefaultSize, wxNO_BORDER, wxString(_T("")));
	wxFlexGridSizer* infosizer = new wxFlexGridSizer(1,1,2,2);
	infosizer->SetFlexibleDirection(wxBOTH);
	infoPanel->SetSizer(infosizer, true);
	infoPanel->SetAutoLayout( true );

	splitterwindow->Initialize(toolpanel);
	splitterwindow->SplitHorizontally(toolpanel, infoPanel);	

	Connect(b1->GetId(), wxEVT_COMMAND_BUTTON_CLICKED, (wxObjectEventFunction)&buttonsMainPanel::onActionButtonPressed1);
	Connect(b2->GetId(), wxEVT_COMMAND_BUTTON_CLICKED, (wxObjectEventFunction)&buttonsMainPanel::onActionButtonPressed1);
	Connect(b3->GetId(), wxEVT_COMMAND_BUTTON_CLICKED, (wxObjectEventFunction)&buttonsMainPanel::onActionButtonPressed1);
	Connect(b4->GetId(), wxEVT_COMMAND_BUTTON_CLICKED, (wxObjectEventFunction)&buttonsMainPanel::onActionButtonPressed1);

	this->Layout();
}

buttonsMainPanel::~buttonsMainPanel(void)
{

}

buttonsMainPanel* buttonsMainPanel::getInstance(wxWindow* parent, std::string datadir, wxEvtHandler *evtHandler)
{
	//wxFrame* newframe = new wxFrame(parent, -1, wxT(" Tools. "), wxPoint(75,50), wxSize(300, 700),wxFRAME_TOOL_WINDOW|wxSYSTEM_MENU | wxCAPTION |  wxCLIP_CHILDREN |wxFRAME_FLOAT_ON_PARENT); // JPR
	wxFrame* newframe = new wxFrame(parent, -1, wxT(" Tools. "), wxPoint(75,50), wxSize(300, 1000),wxFRAME_TOOL_WINDOW|wxSYSTEM_MENU | wxCAPTION |  wxCLIP_CHILDREN |wxFRAME_FLOAT_ON_PARENT);// JPR
																						
	if(mainPanel == NULL)
	{
		mainPanel = new buttonsMainPanel(newframe, 300, /*700*/ 1000, evtHandler, datadir);
	}

	newframe->Show(TRUE);
	return mainPanel;
}

buttonsMainPanel* buttonsMainPanel::getInstance(wxWindow* parent, wxEvtHandler *evtHandler)
{
	wxFrame* newframe = new wxFrame(parent, -1, wxT(" Tools "), wxPoint(75,50)  , wxSize(300, /*700*/ 1000),wxFRAME_TOOL_WINDOW|wxSYSTEM_MENU | wxCAPTION |  wxCLIP_CHILDREN |wxFRAME_FLOAT_ON_PARENT );

	if(mainPanel == NULL)
	{
		mainPanel = new buttonsMainPanel(newframe, 300, /*700*/ 1000, evtHandler);
	}

	newframe->Show(TRUE);
	return mainPanel;
}

buttonsMainPanel* buttonsMainPanel::getInstance()
{	

	return mainPanel;
}

void buttonsMainPanel::onActionButtonPressed1( wxCommandEvent& event )
{
	wxButton* b = (wxButton*)event.GetEventObject();
	wxPanel* dmenu;
	wxStaticText* text;
	std::string dstring = *((std::string*) b->GetClientData());
	int sizechange=0;


	if(dstring.compare(PANEL1)==0 ){
		dmenu = menubar1;	
		text = statictext1;
	} else if(dstring.compare(PANEL2)==0){
		dmenu = menubar2;
		text = statictext2;
	} else if(dstring.compare(PANEL3)==0){
		dmenu = menubar3;
		text = statictext3;
	} else if(dstring.compare(PANEL4)==0){
		dmenu = menubar4;
		text = statictext4;
	}

	if(wxStrcmp(b->GetLabel(),_T("+"))==0 ){
		dmenu->Show(true);
		sizechange = 1;
		b->SetLabel(_T("-"));
	} else{
		dmenu->Show(false);		
		sizechange = -1;
		b->SetLabel(_T("+"));
	}	

	sizechange *= dmenu->GetSize().GetHeight();
	splitterwindow->SetSashPosition(splitterwindow->GetSashPosition()+sizechange);

	this->Layout();
	this->Refresh();
}

wxStaticText* buttonsMainPanel::getText(wxWindow* parent, std::string nom)
{
	return new wxStaticText(parent, -1, wxString(nom.c_str(),wxConvUTF8), wxDefaultPosition, 
							wxDefaultSize, wxALIGN_CENTRE, wxString(nom.c_str(),wxConvUTF8));
}

wxButton* buttonsMainPanel::getButton(wxWindow* parent)
{
	wxButton* b = new wxButton(parent, -1, wxString(_T("-")), wxDefaultPosition, wxDefaultSize, wxBU_EXACTFIT, 
								wxDefaultValidator, wxString(_T("-")));	
	return b;
}

wxPanel* buttonsMainPanel::setMenuTextSizer(wxWindow* parent, wxPanel* panel, wxStaticText* text)
{
	wxFlexGridSizer* flexsizer = new wxFlexGridSizer(2,1,2,2);	
	parent->SetSizer(flexsizer, true);
	parent->SetAutoLayout( true );

	flexsizer->Add(text,  wxFLEX_GROWMODE_ALL);
	flexsizer->Add(panel, wxFLEX_GROWMODE_ALL);

	parent->Layout();
	return (wxPanel*)parent;
}

/**
**	Shows the panel
**/
void buttonsMainPanel::showPanel(wxWindow* panel)
{
	//wxContourMainFrame::getInstance()->showAxis(false);
	wxSizer* sizer = infoPanel->GetSizer();

	if(currentWindow != NULL){
		currentWindow->Hide();
		sizer->Detach(currentWindow);
	}	
	sizer->Add(panel);
	currentWindow = panel;
	currentWindow->Show(true);

	splitterwindow->SetSashPosition(splitterwindow->GetSashPosition()+1);
	splitterwindow->SetSashPosition(splitterwindow->GetSashPosition()-1);

	infoPanel->Layout();
	infoPanel->Refresh();
	this->Layout();
	this->Refresh();
}

/**
**	Gets the Information panel
**/
wxPanel* buttonsMainPanel::getInfoPanel()
{
	return infoPanel;
}

void buttonsMainPanel::onAverage(int selected)
{
	//IRMMainFrame::getInstance()->onAverage(selected);
}
void buttonsMainPanel::onDifferential()
{

}

void buttonsMainPanel::onDifferentialPressed()
{
	if(differentialPanel==NULL){

		differentialPanel = new wxPanel(buttonsMainPanel::getInstance()->getInfoPanel(), -1, wxDefaultPosition, wxDefaultSize, wxBORDER_STATIC, wxString(_T("")));
		wxFlexGridSizer* flexsizer = new wxFlexGridSizer(1);	
		differentialPanel->SetSizer(flexsizer, true);
		differentialPanel->SetAutoLayout( true );	
		panelDifferential = new interfDifferentialPanel(differentialPanel);
	
		wxStaticText* stattext = new wxStaticText(differentialPanel, -1, wxString(_T("   Differential Cartography Tool   ")), wxDefaultPosition,
					wxDefaultSize, wxALIGN_CENTRE|wxBORDER_SIMPLE|wxFULL_REPAINT_ON_RESIZE, wxString(_T("")));

		flexsizer->Add(stattext,wxALIGN_CENTER | wxALIGN_CENTRE);
		flexsizer->Add(panelDifferential, wxEXPAND);
		differentialPanel->Layout();
	}	
	showPanel(differentialPanel);
}

void buttonsMainPanel::onSuperposition(int img1, int img2)
{
	IRMMainFrame::getInstance()->onSuperpositionPanelCreate(img1, img2);
}

void buttonsMainPanel::onSuperpositionPressed()
{
	if(superpositionPanel==NULL)
	{
		superpositionPanel = new wxPanel(buttonsMainPanel::getInstance()->getInfoPanel(), -1, wxDefaultPosition, wxDefaultSize, wxBORDER_STATIC, wxString(_T("")));
		wxFlexGridSizer* flexsizer = new wxFlexGridSizer(1);	
		superpositionPanel->SetSizer(flexsizer, true);
		superpositionPanel->SetAutoLayout( true );	
		panelSuperposition = new interfSuperpositionPanel(superpositionPanel);
	
		wxStaticText* stattext = new wxStaticText(superpositionPanel, -1, wxString(_T("   Superposition Tool   ")), wxDefaultPosition,
			wxDefaultSize, wxALIGN_CENTRE|wxBORDER_SIMPLE|wxFULL_REPAINT_ON_RESIZE, wxString(_T("")));

		flexsizer->Add(stattext,wxALIGN_CENTER | wxALIGN_CENTRE);
		flexsizer->Add(panelSuperposition, wxEXPAND);
		superpositionPanel->Layout();
	}	
	showPanel(superpositionPanel);
}

void buttonsMainPanel::onSignalCurve()
{

}

void buttonsMainPanel::onSignalCurvePressed()
{
	if(signalCurvePanel==NULL)
	{
		signalCurvePanel = new wxPanel(buttonsMainPanel::getInstance()->getInfoPanel(), -1, wxDefaultPosition, wxDefaultSize, wxBORDER_STATIC, wxString(_T("")));
		wxFlexGridSizer* flexsizer = new wxFlexGridSizer(1);	
		signalCurvePanel->SetSizer(flexsizer, true);
		signalCurvePanel->SetAutoLayout( true );	
		panelSignalCurve = new interfSignalCurvePanel(signalCurvePanel);
	
		wxStaticText* stattext = new wxStaticText(signalCurvePanel, -1, wxString(_T("   Signal Curve   ")), wxDefaultPosition,
			wxDefaultSize, wxALIGN_CENTRE|wxBORDER_SIMPLE|wxFULL_REPAINT_ON_RESIZE, wxString(_T("")));

		flexsizer->Add(stattext,wxALIGN_CENTER | wxALIGN_CENTRE);
		flexsizer->Add(panelSignalCurve, wxEXPAND);
		signalCurvePanel->Layout();
	}	
	showPanel(signalCurvePanel);
}

void buttonsMainPanel::onCopy()
{
	
}
void buttonsMainPanel::onPaste()
{

}
void buttonsMainPanel::onUndo()
{

}
void buttonsMainPanel::onRedo()
{

}
void buttonsMainPanel::onNewADC()
{

}
void buttonsMainPanel::onNewADCPressed()
{
	    if(ADCPanel==NULL)
		{
		ADCPanel = new wxPanel(buttonsMainPanel::getInstance()->getInfoPanel(), -1, wxDefaultPosition, wxDefaultSize, wxBORDER_STATIC, wxString(_T("")));
		wxFlexGridSizer* flexsizer = new wxFlexGridSizer(1);	
		ADCPanel->SetSizer(flexsizer, true);
		ADCPanel->SetAutoLayout( true );	
		panelADC = new interfADCPanel(ADCPanel);

		wxStaticText* stattext = new wxStaticText(ADCPanel, -1, wxString(_T("   ADC Cartography Creator  ")), wxDefaultPosition,
			wxDefaultSize, wxALIGN_CENTRE|wxBORDER_SIMPLE|wxFULL_REPAINT_ON_RESIZE, wxString(_T("")));

		flexsizer->Add(stattext, wxALIGN_CENTER | wxALIGN_CENTRE);
		flexsizer->Add(panelADC, wxEXPAND);
		ADCPanel->Layout();
	}	
	showPanel(ADCPanel);
}

void buttonsMainPanel::onNewTTP()
{

}

void buttonsMainPanel::onNewTTPPressed()
{
    if(TTPPanel==NULL)
	{
		TTPPanel = new wxPanel(buttonsMainPanel::getInstance()->getInfoPanel(), -1, wxDefaultPosition, wxDefaultSize, wxBORDER_STATIC, wxString(_T("")));
		wxFlexGridSizer* flexsizer = new wxFlexGridSizer(1);	
		TTPPanel->SetSizer(flexsizer, true);
		TTPPanel->SetAutoLayout( true );	
		panelTTP = new interfTTPPanel(TTPPanel);
	
		wxStaticText* stattext = new wxStaticText(TTPPanel, -1, wxString(_T("   TTP Cartography Creator  ")), wxDefaultPosition,
							wxDefaultSize, wxALIGN_CENTRE|wxBORDER_SIMPLE|wxFULL_REPAINT_ON_RESIZE, wxString(_T("")));

		flexsizer->Add(stattext,wxALIGN_CENTER | wxALIGN_CENTRE);
		flexsizer->Add(panelTTP, wxEXPAND);
		TTPPanel->Layout();
	}	
	showPanel(TTPPanel);
}

void buttonsMainPanel::onSave()
{

}

void buttonsMainPanel::RefreshInterface()
{

}

void buttonsMainPanel::onViewerPressed( )
{
	IRMMainFrame::getInstance()->onCreateViewer();
}

void buttonsMainPanel::onMIPViewerPressed( )
{
	IRMMainFrame::getInstance()->onCreateMIPViewer();
}

void buttonsMainPanel::onContour(int selected)
{
	IRMMainFrame::getInstance()->onContourCreate(selected);
}

void buttonsMainPanel::onContourPressed()
{
	if(contourPanel==NULL){

		contourPanel = new wxPanel(buttonsMainPanel::getInstance()->getInfoPanel(), -1, wxDefaultPosition, wxDefaultSize, wxBORDER_STATIC, wxString(_T("")));
		wxFlexGridSizer* flexsizer = new wxFlexGridSizer(1);	
		contourPanel->SetSizer(flexsizer, true);
		contourPanel->SetAutoLayout( true );
		panelContour = new interfContourPanel(contourPanel);

		wxStaticText* stattext = new wxStaticText(contourPanel, -1, wxString(_T("   Differential Cartography Tool   ")), wxDefaultPosition,
			wxDefaultSize, wxALIGN_CENTRE|wxBORDER_SIMPLE|wxFULL_REPAINT_ON_RESIZE, wxString(_T("")));

		flexsizer->Add(stattext,     wxALIGN_CENTER | wxALIGN_CENTRE);
		flexsizer->Add(panelContour, wxEXPAND);
		contourPanel->Layout();
	}
	showPanel(contourPanel);
}

int buttonsMainPanel::numberOfViewers()
{
	return IRMMainFrame::getInstance()->getNumberOfViewers();
}

int buttonsMainPanel::selectedView()
{
	return IRMMainFrame::getInstance()->getSelectedView();
}

int buttonsMainPanel::getDimZ(int selected)
{
	return IRMMainFrame::getInstance()-> getDimZ(selected);
}

void buttonsMainPanel::updateViewersInfo()
{
	if(contourPanel!=NULL)
	{
		panelContour->updateViewersList();
	}

	if(ADCPanel!=NULL)
	{
		panelADC->updateViewersList();
		panelADC->updateSlices();
	}

/*EED 03-11-2009
	if(TTPPanel!=NULL)
	{
		panelTTP->updateViewersList();
		panelTTP->updateSlices();
	}
*/
	if(superpositionPanel!=NULL)
	{
		panelSuperposition->updateViewersList();
	}
}

void buttonsMainPanel::changeViewer(int sel)
{
	IRMMainFrame::getInstance()-> changeViewer(sel);
}

void buttonsMainPanel::createADC(int inputImage, std::string path, int min, int max, bool addToDB)
{
	IRMMainFrame::getInstance()->createADC(inputImage, path, min, max, addToDB);
}

void buttonsMainPanel::createTTP(std::string path, int min, int max, std::string ficEntreeArt,
			double res_temp, 
			int nbbaseline, 
			int delay, 
			double eps, 
			double TE, 
			double thresnoise, 
			int retard_AIF, 
			int retard_perf,
			
			bool verbose,
			bool cartoMax,
			bool cartoSVD,
			bool cartoARMA,
			bool aff,
			bool enreg,
			bool addToDB,
			int firstSliceToDeal)
{
	IRMMainFrame::getInstance()->createTTP(path, min, max, ficEntreeArt,
			 res_temp,
			 nbbaseline,
			 delay,
			 eps,
			 TE,
			 thresnoise,
			 retard_AIF,
			 retard_perf,
			 verbose,
			 cartoMax,
			 cartoSVD,
			 cartoARMA,
			 aff,
			 enreg,
			 addToDB,
			 firstSliceToDeal
			);
}

void buttonsMainPanel::showWindow()
{
	//show();
}

void buttonsMainPanel::hideWindow()
{
	//hide();
}	
