#ifndef __panelToolsH__
#define __panelToolsH__

#include <wx/wx.h>
#include "mBarRange.h"
#include <wx/grid.h>

// ==================================================================

class interfDifferentialPanel
	: public wxPanel
{
public:
	interfDifferentialPanel(wxWindow * parent);		
	~interfDifferentialPanel();

private:
	wxComboBox* _boxViewer;
	wxComboBox* _boxType;
	wxStaticText* _aveValue;
	void onAverageGo(wxCommandEvent& event);
	void onDifferentialGo(wxCommandEvent& event);
};

// ==================================================================

class interfSuperpositionPanel
	: public wxPanel
{
public:
	interfSuperpositionPanel(wxWindow * parent);		
	~interfSuperpositionPanel();

	void updateViewersList();

private:

	wxComboBox* _boxImage1;
	wxComboBox* _boxImage2;

	void onAlignGo(wxCommandEvent& event);
	void onSuperposeGo(wxCommandEvent& event);
	void onSaveParametersGo(wxCommandEvent& event);
};

// ==================================================================

class interfSignalCurvePanel
	: public wxPanel
{
public:
	interfSignalCurvePanel(wxWindow * parent);		
	~interfSignalCurvePanel();

private:
	wxComboBox* _boxDay;
	wxComboBox* _boxSlice;
	void onSignalCurveGo(wxCommandEvent& event);
};


// ==================================================================

class interfContourPanel
	: public wxPanel
{
public:
	interfContourPanel(wxWindow * parent);		
	~interfContourPanel();

	void updateViewersList();

private:
	wxComboBox* _boxViewer;

	void onContourGo(wxCommandEvent& event);

	void onViewChange(wxCommandEvent& event);
	
	DECLARE_EVENT_TABLE()
};

// ==================================================================

class interfADCPanel
	: public wxPanel
{
public:
	interfADCPanel(wxWindow * parent);		
	~interfADCPanel();

	void updateViewersList();

	void updateSlices();

private:

	mBarRange  * _mBarSlices;
	wxComboBox * _boxViewer;
	wxTextCtrl * _outputPath;
	wxCheckBox * _addCheckBox;	

	void onOutputDir  (wxCommandEvent& event);
        void onGetSelected(wxCommandEvent& event);
	void onCreateADC  (wxCommandEvent& event);

	void onSlidesChange(wxCommandEvent& event);

	void onViewChange(wxCommandEvent& event);

	DECLARE_EVENT_TABLE()
};

// ==================================================================

class interfTTPPanel
	: public wxPanel
{
public:
	interfTTPPanel(wxWindow * parent);		
	~interfTTPPanel();

/*EED 03-11-2009
	void updateViewersList();
	void updateSlices();
*/

private:

	mBarRange  * _mBarSlices;
	wxComboBox * _boxViewer;
	wxTextCtrl * _outputPath;
	wxCheckBox * _armaCheckBox;		
	wxTextCtrl * _res_temp_TextCtrl;
	wxTextCtrl * _nbbaseline_TextCtrl;
	wxTextCtrl * _delay_TextCtrl;	
	wxTextCtrl * _eps_TextCtrl;
	wxTextCtrl * _TE_TextCtrl;
	wxTextCtrl * _thresnoise_TextCtrl;
	wxTextCtrl * _retard_AIF_TextCtrl;	
	wxTextCtrl * _retard_perf_TextCtrl;
	wxTextCtrl * _firstSliceToDeal_TextCtrl;
wxCheckBox * _addCheckBox;

	void onOutputDir(wxCommandEvent& event);
        void onGetSelected(wxCommandEvent& event);	
	void onCreateTTP(wxCommandEvent& event);
	void onSlidesChange(wxCommandEvent& event);

	void onViewChange(wxCommandEvent& event);

	DECLARE_EVENT_TABLE()
};

#endif
