
//----------------------------------------------------------------------------------------------------------------
// Class definition include
//----------------------------------------------------------------------------------------------------------------
#include <vector>
#include "IRMViewPanel.h"
#include "IRMMainFrame.h"


//----------------------------------------------------------------------------------------------------------------
// Other includes
//----------------------------------------------------------------------------------------------------------------
	
	//------------------------------------------------------------------------------------------------------------
	// Constructors & Destructors
	//------------------------------------------------------------------------------------------------------------

	IRMViewPanel :: IRMViewPanel ( vtkImageData * theShowingImage, wxWindow *parent, const wxPoint& pos, const wxSize& size,long style, int vertStart, int vertEnd, int horzStart, int horzEnd )	
	:wxPanel(parent, -1, pos, size, style)		
	{				
		showingVID = theShowingImage;
		int gapH = 20;
		int gapV = 10;
		createViewPanel();

		outSizer = new wxFlexGridSizer(1, 1, gapH, gapV);
		outSizer->AddGrowableCol(0);
		outSizer->AddGrowableRow(0);
		outSizer->Add( theViewPanel, 1, wxGROW);
								
		this->SetSizer( outSizer );
		this->SetAutoLayout( true );
		this->Layout();
	}
	

	IRMViewPanel :: ~IRMViewPanel()
	{

	}

	//------------------------------------------------------------------------------------------------------------
	// Creational and initialization methods
	//------------------------------------------------------------------------------------------------------------
	
	void IRMViewPanel :: createViewPanel()
	{		

		std::vector<int> * numViews = new std::vector<int> ();
		numViews->push_back(0);
		theViewPanel = new wxMaracas_N_ViewersWidget( this, showingVID, numViews );
		SetVisibleAxis(false);

		theViewPanel->SetBackgroundColour(wxColour(0,0,0));

		theViewPanel->SetSize(800, 900);
		theViewPanel->GetWindow(1)->SetSize(800, 900);	
	}

	//------------------------------------------------------------------------------------------------------------

	wxVtkBaseView* IRMViewPanel :: GetWxVtkBaseView()
	{
		return theViewPanel->GetwxVtkBaseView(1);
	}


	wxVtkMPR2DView * IRMViewPanel::GetwxVtkMPR2DView() 
	{
		return (wxVtkMPR2DView *) (theViewPanel->GetwxVtkBaseView(1));
	}

	vtkImageData * IRMViewPanel::GetshowingVID() 
	{
		return showingVID;
	}

	int IRMViewPanel::GetImageDataSizeZ()
	{
		int ext[6];
		showingVID->GetExtent(ext);
		int sizeZ = ext[5]-ext[4]+1;

		return sizeZ;
	}

	void IRMViewPanel :: RefreshInterface()
	{
		GetWxVtkBaseView()->Refresh();
	}

	void IRMViewPanel :: ChangeImage(vtkImageData* img)
	{
		theViewPanel->SetImage(img);
	}
	
	//------------------------------------------------------------------------------------------------------------
	//  Other functional methods
	//------------------------------------------------------------------------------------------------------------

	void IRMViewPanel::SetVisibleAxis(bool ok)
	{
		GetwxVtkMPR2DView()->SetVisibleAxis(ok);
	}

	//------------------------------------------------------------------------------------------------------------
	int IRMViewPanel::GetX()
	{
		return  GetwxVtkMPR2DView()->GetVtkmprbasedata()->GetX();
	}
	//------------------------------------------------------------------------------------------------------------
	int IRMViewPanel::GetY()
	{
		return  GetwxVtkMPR2DView()->GetVtkmprbasedata()->GetY();
	}
	//------------------------------------------------------------------------------------------------------------
	int IRMViewPanel::GetZ()
	{
		return  GetwxVtkMPR2DView()->GetVtkmprbasedata()->GetZ();
	}

	//------------------------------------------------------------------------------------------------------------
	void IRMViewPanel::Refresh()
	{
		GetwxVtkMPR2DView()->GetRenWin()->Render();
	}
