#ifndef __IRMViewPanel_h_INCLUDED_H__
#define __IRMViewPanel_h_INCLUDED_H__


// -----------------------------------------------------------------------------------------------------------
// WX headers inclusion.
// For compilers that support precompilation, includes <wx/wx.h>.
// -----------------------------------------------------------------------------------------------------------

#include <wx/wxprec.h>
#ifdef __BORLANDC__
#pragma hdrstop
#endif
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

#include <wx/scrolwin.h>

//------------------------------------------------------------------------------------------------------------
// Includes
//------------------------------------------------------------------------------------------------------------

#include "wxMaracas_N_ViewersWidget.h"
#include "vtkImageData.h"
#include "wxVtkBaseView.h"
#include <wx/event.h>


//------------------------------------------------------------------------------------------------------------
// Class definition
//------------------------------------------------------------------------------------------------------------

class IRMViewPanel : public wxPanel 
{

	public:

	//------------------------------------------------------------------------------------------------------------
	// Constructors & Destructors
	//------------------------------------------------------------------------------------------------------------
	
	IRMViewPanel( vtkImageData * theShowingImage, wxWindow *parent, const wxPoint& pos=wxDefaultPosition, const wxSize& size = wxDefaultSize,long style= wxDEFAULT_FRAME_STYLE | wxSUNKEN_BORDER, int vertStart=1, int vertEnd=1, int horzStart=1, int horzEnd=1 );

	~IRMViewPanel();

	//------------------------------------------------------------------------------------------------------------
	// Creational and initialization methods
	//------------------------------------------------------------------------------------------------------------

	void createViewPanel();

	//------------------------------------------------------------------------------------------------------------
	//  Other functional methods
	//------------------------------------------------------------------------------------------------------------

	void getSpacing( double * spacing );

	wxVtkBaseView* GetWxVtkBaseView();
	wxVtkMPR2DView * GetwxVtkMPR2DView();
	vtkImageData * GetshowingVID();
	int GetImageDataSizeZ();
	void RefreshInterface();
	void ChangeImage(vtkImageData* img);
	
	void	SetVisibleAxis(bool ok);
	int		GetX();
	int		GetY();
	int		GetZ();
	void	Refresh();

	//------------------------------------------------------------------------------------------------------------
	// Attributtes
	//------------------------------------------------------------------------------------------------------------
private:
	
	/*
	* Represents the outer sizer of the IRMViewPanel
	*/
	wxFlexGridSizer* outSizer;

	/*
	* Represents the panel for viewing
	*/
	wxMaracas_N_ViewersWidget * theViewPanel;


	vtkImageData * showingVID;	


	double last_spacing[3];
};

#endif

